/* $Id: settings.inc 747 2006-08-25 04:02:34Z AustinHeilman $
 *
 */

use uo;
use os;
use cfgfile;

/*
 * EML_GetSettingsCfgFile(engine_name)
 *
 * Purpose
 * Reads in :email:configs/settings.cfg
 *
 * Parameters
 *
 * Return value
 * A config file reference.
 *
 */
function EML_GetSettingsCfgFile()
	var cfg := ReadConfigFile(":email:settings");

	if ( cfg.errortext )
		SysLog("Error::EML_GetSettingsCfgFile() - Unable to open [:email:settings.cfg] ->"+cfg.errortext);
	endif

	return cfg;
endfunction

/*
 * EML_GetSettingsCfgElem(elem_name, cfg_file)
 *
 * Purpose
 * Retrieves an elem from a config file.
 *
 * Parameters
 * elem_name:	A string matching the elem name to be retrieved.
 * cfg_file:	Optional parameter - reference to a config already read in by EML_GetSettingsCfgFile()
 *
 * Return value
 * A config file elem reference.
 *
 */
function EML_GetSettingsCfgElem(elem_name, byref cfg_file:=0)
	if ( !cfg_file )
		cfg_file := EML_GetSettingsCfgFile();
	endif

	var elem := cfg_file[elem_name];

	if ( elem.errortext )
		SysLog("Error::EML_GetSettingsCfgElem() - Unable to find elem ["+elem_name+"] ->"+elem.errortext);
	endif

	return elem;
endfunction
